// SPDX-License-Identifier: AGPL-3.0-only

pragma solidity >=0.8.0;

import '../base/interfaces/IStandardERC20.sol';
import '../base/interfaces/IERC4626.sol';
import '../base/utils/StringUtils.sol';
import '../base/utils/PreciseUnitMath.sol';
import '../base/utils/ExplicitERC20.sol';
import '../base/utils/Initializable.sol';
import '../common/libs/FactoryAccess.sol';
import '../common/interfaces/IEmergencyShutdown.sol';
import '../common/interfaces/IDeployment.sol';
import '../common/FactoryConditions.sol';
import '../common/ERC2771Context.sol';
import '../common/roles/StandardAccessControlEnumerable.sol';
import '../cross-chain/interfaces/ICCIPBridge.sol';
import '../cross-chain/CCIPReceiver.sol';
import '../cross-chain/CCIPBridge.sol';
import '../test/MockAggregator.sol';
import '../test/MockCCIPRouter.sol';
import '../test/MockRandomAggregator.sol';
import '../test/TestnetERC20.sol';
import '../test/TestnetSelfMintingERC20.sol';
import '../test/SelfMintingControllerMock.sol';
import '../test/CreditLineControllerMock.sol';
import '../test/MockOnChainOracle.sol';
import '../test/PriceFeedGetter.sol';
import '../test/UtilsMock.sol';
import '../test/DerivativeMock.sol';
import '../test/PoolMock.sol';
import '../test/PoolLendingMock.sol';
import '../test/MockPoolForVault.sol';
import '../test/WrongTypology.sol';
import '../test/PoolRegistryMock.sol';
import '../test/MockContext.sol';
import '../test/MockCreditLineContext.sol';
import '../test/PoolAnalyticsMock.sol';
import '../test/MockDiaOracle.sol';
import '../test/MockServer.sol';
import '../test/lending-module/LendingModulelMock.sol';
import '../test/lending-module/LendingTestnetERC20.sol';
import '../test/ISwapRouter02.sol';
import '../oracle/PriceFeed.sol';
import '../oracle/interfaces/IPriceFeed.sol';
import '../oracle/implementations/interfaces/IDapiServer.sol';
import '../oracle/implementations/interfaces/IDiaPriceFeed.sol';
import '../oracle/implementations/interfaces/IPriceFeedImplementation.sol';
import '../oracle/implementations/PriceFeedImplementation.sol';
import '../oracle/implementations/ChainlinkPriceFeed.sol';
import '../oracle/implementations/Api3PriceFeed.sol';
import '../oracle/implementations/DiaPriceFeed.sol';
import '../oracle/implementations/ERC4626PriceFeed.sol';
import '../synthereum-pool/common/migration/PoolMigration.sol';
import '../synthereum-pool/common/migration/PoolMigrationFrom.sol';
import '../synthereum-pool/common/migration/PoolMigrationTo.sol';
import '../synthereum-pool/common/migration/interfaces/IPoolMigrationStorage.sol';
import '../synthereum-pool/common/interfaces/ILendingTransfer.sol';
import '../synthereum-pool/common/interfaces/ILendingRewards.sol';
import '../synthereum-pool/common/interfaces/IPoolVault.sol';
import '../synthereum-pool/v4/interfaces/IPoolOnChainPriceFeed.sol';
import '../synthereum-pool/v5/interfaces/ILiquidityPoolGeneral.sol';
import '../synthereum-pool/v5/interfaces/ILiquidityPoolInteraction.sol';
import '../synthereum-pool/v5/interfaces/ILiquidityPool.sol';
import '../synthereum-pool/v5/interfaces/ILiquidityPoolStorage.sol';
import '../synthereum-pool/v5/LiquidityPool.sol';
import '../synthereum-pool/v5/LiquidityPoolLib.sol';
import '../synthereum-pool/v5/LiquidityPoolCreator.sol';
import '../synthereum-pool/v5/LiquidityPoolFactory.sol';
import '../synthereum-pool/v6/interfaces/IMultiLpLiquidityPoolEvents.sol';
import '../synthereum-pool/v6/interfaces/IMultiLpLiquidityPool.sol';
import '../synthereum-pool/v6/MultiLpLiquidityPoolWithRewards.sol';
import '../synthereum-pool/v6/MultiLpLiquidityPool.sol';
import '../synthereum-pool/v6/MultiLpLiquidityPoolLib.sol';
import '../synthereum-pool/v6/MultiLpLiquidityPoolMainLib.sol';
import '../synthereum-pool/v6/MultiLpLiquidityPoolMigrationLib.sol';
import '../synthereum-pool/v6/MultiLpLiquidityPoolCreator.sol';
import '../synthereum-pool/v6/MultiLpLiquidityPoolFactory.sol';
import '../core/Manager.sol';
import '../core/FactoryVersioning.sol';
import '../core/Finder.sol';
import '../core/interfaces/IFinder.sol';
import '../core/interfaces/IManager.sol';
import '../core/interfaces/IFactoryVersioning.sol';
import '../core/interfaces/IDeploymentSignature.sol';
import '../core/interfaces/IMigrationSignature.sol';
import '../core/interfaces/IDeployer.sol';
import '../core/Constants.sol';
import '../core/Deployer.sol';
import '../core/CollateralWhitelist.sol';
import '../core/IdentifierWhitelist.sol';
import '../core/TrustedForwarder.sol';
import '../core/interfaces/ICollateralWhitelist.sol';
import '../core/interfaces/IIdentifierWhitelist.sol';
import '../core/registries/SelfMintingRegistry.sol';
import '../core/registries/interfaces/IRegistry.sol';
import '../core/registries/interfaces/IPublicVaultRegistry.sol';
import '../core/registries/Registry.sol';
import '../core/registries/PoolRegistry.sol';
import '../core/registries/PublicVaultRegistry.sol';
import '../central-bank/interfaces/IMoneyMarketManager.sol';
import '../central-bank/interfaces/IJarvisBrrrrr.sol';
import '../central-bank/interfaces/IJarvisBrrMoneyMarket.sol';
import '../central-bank/MoneyMarketManager.sol';
import '../central-bank/modules/JarvisBrrAave.sol';
import '../central-bank/modules/JarvisBrrCompound.sol';
import '../central-bank/JarvisBrrrrr.sol';
import '../self-minting/v1/interfaces/ISelfMintingMultiParty.sol';
import '../self-minting/v2/CreditLineCreator.sol';
import '../self-minting/v2/CreditLineFactory.sol';
import '../self-minting/v2/CreditLineController.sol';
import '../self-minting/v2/interfaces/ICreditLine.sol';
import '../self-minting/v2/interfaces/ICreditLineController.sol';
import '../tokens/MintableBurnableSyntheticToken.sol';
import '../tokens/MintableBurnableSyntheticTokenPermit.sol';
import '../tokens/BaseControlledMintableBurnableERC20.sol';
import '../tokens/interfaces/IMintableBurnableERC20.sol';
import '../tokens/factories/interfaces/IMintableBurnableTokenFactory.sol';
import '../tokens/MintableBurnableERC20.sol';
import '../tokens/factories/MintableBurnableTokenFactory.sol';
import '../tokens/factories/SyntheticTokenFactory.sol';
import '../tokens/factories/SyntheticTokenPermitFactory.sol';
import '../core/registries/FixedRateRegistry.sol';
import '../fixed-rate/v1/FixedRateCreator.sol';
import '../fixed-rate/v1/FixedRateFactory.sol';
import '../fixed-rate/v1/FixedRateWrapper.sol';
import '../fixed-rate/v1/interfaces/IFixedRateWrapper.sol';
import '../lending-module/LendingManager.sol';
import '../lending-module/LendingStorageManager.sol';
import '../lending-module/lending-modules/AaveV3.sol';
import '../lending-module/lending-modules/Compound.sol';
import '../lending-module/swap-modules/Univ2JRTSwap.sol';
import '../lending-module/swap-modules/BalancerJRTSwap.sol';
import '../lending-module/interfaces/IAaveV3.sol';
import '../lending-module/interfaces/IAaveV3.sol';
import '../lending-module/interfaces/IBalancerVault.sol';
import '../lending-module/interfaces/IJrtSwapModule.sol';
import '../lending-module/interfaces/ILendingManager.sol';
import '../lending-module/interfaces/ILendingModule.sol';
import '../lending-module/interfaces/ILendingStorageManager.sol';
import '../lending-module/interfaces/IRewardsController.sol';
import '../jarvis-tokens/debt/DebtToken.sol';
import '../jarvis-tokens/debt/DebtTokenFactory.sol';
import '../jarvis-tokens/debt/interfaces/IDebtToken.sol';
import '../jarvis-tokens/jarvis/ConverterActivator.sol';
import '../jarvis-tokens/jarvis/Converter.sol';
import '../jarvis-tokens/jarvis/WrapperConverter.sol';
import '../jarvis-tokens/jarvis/JarvisToken.sol';
import '../jarvis-tokens/jarvis/JarvisTokenImplementation.sol';
import '../multiLP-vaults/Vault.sol';
import '../multiLP-vaults/BaseVaultStorage.sol';
import '../multiLP-vaults/interfaces/IVault.sol';
import '../multiLP-vaults/interfaces/IVaultFactory.sol';
import '../multiLP-vaults/VaultCreator.sol';
import '../multiLP-vaults/VaultFactory.sol';
